searchData={"items":[{"type":"module","title":"ExIceberg","doc":"","ref":"ExIceberg.html"},{"type":"module","title":"ExIceberg.Rest.Catalog","doc":"REST catalog implementation using Rust NIFs.","ref":"ExIceberg.Rest.Catalog.html"},{"type":"function","title":"ExIceberg.Rest.Catalog.create_namespace/3","doc":"Creates a new namespace in the catalog.","ref":"ExIceberg.Rest.Catalog.html#create_namespace/3"},{"type":"function","title":"Parameters - ExIceberg.Rest.Catalog.create_namespace/3","doc":"- `catalog` - The catalog struct\n- `namespace` - The namespace name as a string\n- `properties` - Map of properties for the namespace","ref":"ExIceberg.Rest.Catalog.html#create_namespace/3-parameters"},{"type":"function","title":"Returns - ExIceberg.Rest.Catalog.create_namespace/3","doc":"`{:ok, updated_catalog, response}` - Success with response map\n`{:error, updated_catalog, reason}` - Error with reason","ref":"ExIceberg.Rest.Catalog.html#create_namespace/3-returns"},{"type":"function","title":"Examples - ExIceberg.Rest.Catalog.create_namespace/3","doc":"{:ok, catalog, response} = ExIceberg.Rest.Catalog.create_namespace(catalog, \"my_namespace\", %{})\n    # response might be %{\"namespace\" => [\"my_namespace\"]}","ref":"ExIceberg.Rest.Catalog.html#create_namespace/3-examples"},{"type":"function","title":"ExIceberg.Rest.Catalog.create_table/5","doc":"Creates a table in the catalog using structured field definitions.","ref":"ExIceberg.Rest.Catalog.html#create_table/5"},{"type":"function","title":"Parameters - ExIceberg.Rest.Catalog.create_table/5","doc":"- `catalog` - The catalog struct\n- `namespace` - The namespace name as a string\n- `table_name` - The table name as a string\n- `fields` - List of `ExIceberg.Types.Field` structs\n- `properties` - Map of table properties (optional)","ref":"ExIceberg.Rest.Catalog.html#create_table/5-parameters"},{"type":"function","title":"Returns - ExIceberg.Rest.Catalog.create_table/5","doc":"`{:ok, updated_catalog, response}` - Success with response map\n`{:error, updated_catalog, reason}` - Error with reason","ref":"ExIceberg.Rest.Catalog.html#create_table/5-returns"},{"type":"function","title":"Note - ExIceberg.Rest.Catalog.create_table/5","doc":"This function now uses the structured type system. For defining tables,\nit's recommended to use `ExIceberg.Schema` for a more declarative approach:\n\n    defmodule MySchema do\n      use ExIceberg.Schema\n\n      schema \"my_table\" do\n        field :id, :long, required: true\n        field :name, :string\n        field :balance, ExIceberg.Types.decimal(10, 2)\n      end\n    end\n\n    MySchema.create_table(catalog, namespace)","ref":"ExIceberg.Rest.Catalog.html#create_table/5-note"},{"type":"function","title":"Examples - ExIceberg.Rest.Catalog.create_table/5","doc":"# Using structured field definitions directly\n    fields = [\n      ExIceberg.Types.field(\"id\", :long, required: true),\n      ExIceberg.Types.field(\"name\", :string),\n      ExIceberg.Types.field(\"balance\", ExIceberg.Types.decimal(10, 2)),\n      ExIceberg.Types.field(\"tags\", ExIceberg.Types.list(:string)),\n      ExIceberg.Types.field(\"address\", ExIceberg.Types.struct([\n        ExIceberg.Types.field(\"street\", :string),\n        ExIceberg.Types.field(\"city\", :string)\n      ]))\n    ]\n\n    {:ok, catalog, response} = ExIceberg.Rest.Catalog.create_table(catalog, \"my_namespace\", \"my_table\", fields, %{\"owner\" => \"test\"})","ref":"ExIceberg.Rest.Catalog.html#create_table/5-examples"},{"type":"function","title":"ExIceberg.Rest.Catalog.drop_table/3","doc":"Drops a table from the catalog.","ref":"ExIceberg.Rest.Catalog.html#drop_table/3"},{"type":"function","title":"Parameters - ExIceberg.Rest.Catalog.drop_table/3","doc":"- `catalog` - The catalog struct\n- `namespace` - The namespace name as a string\n- `table_name` - The table name as a string","ref":"ExIceberg.Rest.Catalog.html#drop_table/3-parameters"},{"type":"function","title":"Returns - ExIceberg.Rest.Catalog.drop_table/3","doc":"`{:ok, updated_catalog, response}` - Success with response map\n`{:error, updated_catalog, reason}` - Error with reason","ref":"ExIceberg.Rest.Catalog.html#drop_table/3-returns"},{"type":"function","title":"Examples - ExIceberg.Rest.Catalog.drop_table/3","doc":"{:ok, catalog, response} = ExIceberg.Rest.Catalog.drop_table(catalog, \"my_namespace\", \"my_table\")\n    # response might be %{\"table\" => \"my_namespace.my_table\"}","ref":"ExIceberg.Rest.Catalog.html#drop_table/3-examples"},{"type":"function","title":"ExIceberg.Rest.Catalog.list_namespaces/1","doc":"Lists all namespaces in the catalog.","ref":"ExIceberg.Rest.Catalog.html#list_namespaces/1"},{"type":"function","title":"Parameters - ExIceberg.Rest.Catalog.list_namespaces/1","doc":"- `catalog` - The catalog struct","ref":"ExIceberg.Rest.Catalog.html#list_namespaces/1-parameters"},{"type":"function","title":"Returns - ExIceberg.Rest.Catalog.list_namespaces/1","doc":"`{:ok, updated_catalog, namespaces}` - Success with list of namespace names\n`{:error, updated_catalog, reason}` - Error with reason","ref":"ExIceberg.Rest.Catalog.html#list_namespaces/1-returns"},{"type":"function","title":"Examples - ExIceberg.Rest.Catalog.list_namespaces/1","doc":"{:ok, catalog, namespaces} = ExIceberg.Rest.Catalog.list_namespaces(catalog)\n    # namespaces might be [\"default\", \"analytics\", \"staging\"]","ref":"ExIceberg.Rest.Catalog.html#list_namespaces/1-examples"},{"type":"function","title":"ExIceberg.Rest.Catalog.new/2","doc":"Creates a new REST catalog instance.","ref":"ExIceberg.Rest.Catalog.html#new/2"},{"type":"function","title":"Parameters - ExIceberg.Rest.Catalog.new/2","doc":"- `name` - The name of the catalog\n- `config` - Configuration map containing REST catalog settings","ref":"ExIceberg.Rest.Catalog.html#new/2-parameters"},{"type":"function","title":"Returns - ExIceberg.Rest.Catalog.new/2","doc":"`%ExIceberg.Rest.Catalog{}` - The catalog struct","ref":"ExIceberg.Rest.Catalog.html#new/2-returns"},{"type":"function","title":"Examples - ExIceberg.Rest.Catalog.new/2","doc":"config = %{\n      uri: \"http://localhost:8181\",\n      token: \"my-token\",\n      warehouse: \"s3://my-bucket/warehouse\"\n    }\n\n    # Or with OAuth2:\n    config = %{\n      uri: \"http://localhost:8181\",\n      credential: \"client_id:client_secret\",\n      oauth2_server_uri: \"http://keycloak:8080/realms/iceberg/protocol/openid-connect/token\",\n      scope: \"lakekeeper\",\n      warehouse: \"s3://my-bucket/warehouse\"\n    }\n    catalog = ExIceberg.Rest.Catalog.new(\"my_catalog\", config)","ref":"ExIceberg.Rest.Catalog.html#new/2-examples"},{"type":"function","title":"ExIceberg.Rest.Catalog.table_exists?/3","doc":"Checks if a table exists in the catalog.","ref":"ExIceberg.Rest.Catalog.html#table_exists?/3"},{"type":"function","title":"Parameters - ExIceberg.Rest.Catalog.table_exists?/3","doc":"- `catalog` - The catalog struct\n- `namespace` - The namespace name as a string\n- `table_name` - The table name as a string","ref":"ExIceberg.Rest.Catalog.html#table_exists?/3-parameters"},{"type":"function","title":"Returns - ExIceberg.Rest.Catalog.table_exists?/3","doc":"`{:ok, updated_catalog, exists}` - Success with boolean indicating if table exists\n`{:error, updated_catalog, reason}` - Error with reason","ref":"ExIceberg.Rest.Catalog.html#table_exists?/3-returns"},{"type":"function","title":"Examples - ExIceberg.Rest.Catalog.table_exists?/3","doc":"{:ok, catalog, exists} = ExIceberg.Rest.Catalog.table_exists?(catalog, \"my_namespace\", \"my_table\")\n    # exists is true or false","ref":"ExIceberg.Rest.Catalog.html#table_exists?/3-examples"},{"type":"type","title":"ExIceberg.Rest.Catalog.t/0","doc":"","ref":"ExIceberg.Rest.Catalog.html#t:t/0"},{"type":"module","title":"ExIceberg.Schema","doc":"Schema definition for Iceberg tables using a declarative API similar to Ecto.Schema.\n\nThis module provides macros to define table schemas with proper type safety\nand a more Elixir-like API for working with Apache Iceberg tables.","ref":"ExIceberg.Schema.html"},{"type":"module","title":"Example - ExIceberg.Schema","doc":"defmodule MyApp.UserSchema do\n      use ExIceberg.Schema\n\n      schema \"users\" do\n        field :id, :long, required: true\n        field :name, :string\n        field :email, :string, required: true\n        field :age, :int\n        field :active, :boolean, default: true\n        field :metadata, ExIceberg.Types.map(:string, :string)\n        field :tags, ExIceberg.Types.list(:string)\n        field :address, ExIceberg.Types.struct([\n          ExIceberg.Types.field(\"street\", :string),\n          ExIceberg.Types.field(\"city\", :string),\n          ExIceberg.Types.field(\"zip\", :int)\n        ])\n        field :balance, ExIceberg.Types.decimal(10, 2)\n        field :created_at, :timestamp, required: true\n        field :updated_at, :timestamptz\n      end\n    end\n\n    # Usage:\n    {:ok, catalog, _} = MyApp.UserSchema.create_table(catalog, \"my_namespace\")","ref":"ExIceberg.Schema.html#module-example"},{"type":"module","title":"Supported Types - ExIceberg.Schema","doc":"","ref":"ExIceberg.Schema.html#module-supported-types"},{"type":"module","title":"Primitive Types - ExIceberg.Schema","doc":"- `:boolean` - True or false\n- `:int` - 32-bit signed integer\n- `:long` - 64-bit signed integer\n- `:float` - 32-bit IEEE 754 floating point\n- `:double` - 64-bit IEEE 754 floating point\n- `:string` - UTF-8 character sequences\n- `:uuid` - Universally unique identifiers\n- `:date` - Calendar date without timezone\n- `:time` - Time of day in microsecond precision\n- `:timestamp` - Timestamp in microsecond precision, without timezone\n- `:timestamptz` - Timestamp in microsecond precision, with timezone\n- `:binary` - Arbitrary-length byte array","ref":"ExIceberg.Schema.html#module-primitive-types"},{"type":"module","title":"Complex Types - ExIceberg.Schema","doc":"Use the helper functions from `ExIceberg.Types`:\n- `ExIceberg.Types.decimal(precision, scale)` - Fixed point decimal\n- `ExIceberg.Types.fixed(length)` - Fixed-length byte array\n- `ExIceberg.Types.list(element_type, opts)` - List of elements\n- `ExIceberg.Types.map(key_type, value_type, opts)` - Map of key-value pairs\n- `ExIceberg.Types.struct(fields)` - Struct with named fields","ref":"ExIceberg.Schema.html#module-complex-types"},{"type":"module","title":"Field Options - ExIceberg.Schema","doc":"- `:required` - Whether the field is required (default: false)\n- `:field_id` - Explicit field ID (auto-assigned if not provided)","ref":"ExIceberg.Schema.html#module-field-options"},{"type":"macro","title":"ExIceberg.Schema.field/3","doc":"Defines a field in the table schema.","ref":"ExIceberg.Schema.html#field/3"},{"type":"macro","title":"Parameters - ExIceberg.Schema.field/3","doc":"- `name` - The field name (atom)\n- `type` - The field type (atom or structured type)\n- `opts` - Field options (keyword list)","ref":"ExIceberg.Schema.html#field/3-parameters"},{"type":"macro","title":"Examples - ExIceberg.Schema.field/3","doc":"field :id, :long, required: true\n    field :price, ExIceberg.Types.decimal(10, 2)\n    field :tags, ExIceberg.Types.list(:string, element_required: false)\n    field :metadata, ExIceberg.Types.map(:string, :string)\n    field :address, ExIceberg.Types.struct([\n      ExIceberg.Types.field(\"street\", :string),\n      ExIceberg.Types.field(\"city\", :string)\n    ])","ref":"ExIceberg.Schema.html#field/3-examples"},{"type":"macro","title":"ExIceberg.Schema.schema/2","doc":"Defines the table schema with the given name and fields.","ref":"ExIceberg.Schema.html#schema/2"},{"type":"macro","title":"Example - ExIceberg.Schema.schema/2","doc":"schema \"my_table\" do\n      field :id, :long, required: true\n      field :name, :string\n    end","ref":"ExIceberg.Schema.html#schema/2-example"},{"type":"module","title":"ExIceberg.Types","doc":"Type definitions for Iceberg schemas.\n\nThis module provides structured type definitions that correspond to the Rust NIF types,\noffering a more type-safe and idiomatic approach compared to string-based type definitions.","ref":"ExIceberg.Types.html"},{"type":"function","title":"ExIceberg.Types.decimal/2","doc":"Creates a decimal type with the specified precision and scale.","ref":"ExIceberg.Types.html#decimal/2"},{"type":"function","title":"Examples - ExIceberg.Types.decimal/2","doc":"iex> ExIceberg.Types.decimal(10, 2)\n    {:decimal, precision: 10, scale: 2}","ref":"ExIceberg.Types.html#decimal/2-examples"},{"type":"function","title":"ExIceberg.Types.field/3","doc":"Creates a new field with the given name, type, and options.","ref":"ExIceberg.Types.html#field/3"},{"type":"function","title":"Examples - ExIceberg.Types.field/3","doc":"iex> ExIceberg.Types.field(\"id\", :long, required: true)\n    %ExIceberg.Types.Field{name: \"id\", field_type: :long, required: true, field_id: nil}\n\n    iex> ExIceberg.Types.field(\"price\", {:decimal, precision: 10, scale: 2})\n    %ExIceberg.Types.Field{name: \"price\", field_type: {:decimal, precision: 10, scale: 2}, required: false, field_id: nil}","ref":"ExIceberg.Types.html#field/3-examples"},{"type":"function","title":"ExIceberg.Types.fixed/1","doc":"Creates a fixed-length binary type with the specified length.","ref":"ExIceberg.Types.html#fixed/1"},{"type":"function","title":"Examples - ExIceberg.Types.fixed/1","doc":"iex> ExIceberg.Types.fixed(16)\n    {:fixed, length: 16}","ref":"ExIceberg.Types.html#fixed/1-examples"},{"type":"function","title":"ExIceberg.Types.list/2","doc":"Creates a list type with the specified element type.","ref":"ExIceberg.Types.html#list/2"},{"type":"function","title":"Examples - ExIceberg.Types.list/2","doc":"iex> ExIceberg.Types.list(:string)\n    {:list, element_type: :string, element_required: false}\n\n    iex> ExIceberg.Types.list(:int, element_required: true)\n    {:list, element_type: :int, element_required: true}","ref":"ExIceberg.Types.html#list/2-examples"},{"type":"function","title":"ExIceberg.Types.map/3","doc":"Creates a map type with the specified key and value types.","ref":"ExIceberg.Types.html#map/3"},{"type":"function","title":"Examples - ExIceberg.Types.map/3","doc":"iex> ExIceberg.Types.map(:string, :int)\n    {:map, key_type: :string, value_type: :int, value_required: false}\n\n    iex> ExIceberg.Types.map(:string, :string, value_required: true)\n    {:map, key_type: :string, value_type: :string, value_required: true}","ref":"ExIceberg.Types.html#map/3-examples"},{"type":"function","title":"ExIceberg.Types.struct/1","doc":"Creates a struct type with the specified fields.","ref":"ExIceberg.Types.html#struct/1"},{"type":"function","title":"Examples - ExIceberg.Types.struct/1","doc":"iex> ExIceberg.Types.struct([\n    ...>   ExIceberg.Types.field(\"street\", :string),\n    ...>   ExIceberg.Types.field(\"city\", :string),\n    ...>   ExIceberg.Types.field(\"zip\", :int)\n    ...> ])\n    {:struct, fields: [\n      %ExIceberg.Types.Field{name: \"street\", field_type: :string, required: false, field_id: nil},\n      %ExIceberg.Types.Field{name: \"city\", field_type: :string, required: false, field_id: nil},\n      %ExIceberg.Types.Field{name: \"zip\", field_type: :int, required: false, field_id: nil}\n    ]}","ref":"ExIceberg.Types.html#struct/1-examples"},{"type":"type","title":"ExIceberg.Types.type/0","doc":"","ref":"ExIceberg.Types.html#t:type/0"},{"type":"module","title":"ExIceberg.Types.Decimal","doc":"Represents a decimal type with precision and scale.","ref":"ExIceberg.Types.Decimal.html"},{"type":"type","title":"ExIceberg.Types.Decimal.t/0","doc":"","ref":"ExIceberg.Types.Decimal.html#t:t/0"},{"type":"module","title":"ExIceberg.Types.Field","doc":"Represents a field in an Iceberg table schema.\n\nThis struct is used to define table fields with proper type safety\nand corresponds directly to the Rust `IcebergField` struct.","ref":"ExIceberg.Types.Field.html"},{"type":"type","title":"ExIceberg.Types.Field.t/0","doc":"","ref":"ExIceberg.Types.Field.html#t:t/0"},{"type":"module","title":"ExIceberg.Types.Fixed","doc":"Represents a fixed-length binary type.","ref":"ExIceberg.Types.Fixed.html"},{"type":"type","title":"ExIceberg.Types.Fixed.t/0","doc":"","ref":"ExIceberg.Types.Fixed.html#t:t/0"},{"type":"module","title":"ExIceberg.Types.List","doc":"Represents a list type with element type and requirements.","ref":"ExIceberg.Types.List.html"},{"type":"type","title":"ExIceberg.Types.List.t/0","doc":"","ref":"ExIceberg.Types.List.html#t:t/0"},{"type":"module","title":"ExIceberg.Types.Map","doc":"Represents a map type with key-value types and requirements.","ref":"ExIceberg.Types.Map.html"},{"type":"type","title":"ExIceberg.Types.Map.t/0","doc":"","ref":"ExIceberg.Types.Map.html#t:t/0"},{"type":"module","title":"ExIceberg.Types.Struct","doc":"Represents a struct type with named fields.","ref":"ExIceberg.Types.Struct.html"},{"type":"type","title":"ExIceberg.Types.Struct.t/0","doc":"","ref":"ExIceberg.Types.Struct.html#t:t/0"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}